Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 226789 - nfs failover does not work properly when specifying nfs_lock_workaround
Summary: nfs failover does not work properly when specifying nfs_lock_workaround
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Cluster Suite
Classification: Retired
Component: clumanager
Version: 3
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Lon Hohberger
QA Contact: Cluster QE
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2007-02-01 16:42 UTC by Josef Bacik
Modified: 2009-04-16 20:21 UTC (History)
2 users (show)

Fixed In Version: RHBA-2007-0165
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2007-06-14 12:53:47 UTC


Attachments (Terms of Use)
patch to fix problem. (deleted)
2007-02-01 16:42 UTC, Josef Bacik
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2007:0165 normal SHIPPED_LIVE clumanager bug fix update 2007-06-14 12:53:20 UTC

Description Josef Bacik 2007-02-01 16:42:09 UTC
Description of problem:
If you specify a specific nfsclient, and you have nfs_lock_workaround 
specified, the nfs script will do an exportfs -u *:/dir, but that won't 
actually match properly and the mount will not be unexported.  This patch 
fixes the problem.

Comment 1 Josef Bacik 2007-02-01 16:42:09 UTC
Created attachment 147113 [details]
patch to fix problem.

Comment 2 Lon Hohberger 2007-02-01 17:02:02 UTC
The patch is just a reversion to 1.5 from CVS:

Index: src/services/svclib_nfs
===================================================================
RCS file: /cvs/devel/clumanager/src/services/svclib_nfs,v
retrieving revision 1.7
diff -u -r1.7 svclib_nfs
--- src/services/svclib_nfs     16 Jun 2006 16:45:20 -0000      1.7
+++ src/services/svclib_nfs     1 Feb 2007 17:01:44 -0000
@@ -18,7 +18,7 @@
 #  MA 02139, USA.
 #
 
-# $Revision: 1.7 $
+# $Revision: 1.5 $
 #
 # Author: Tim Burke <tburke at redhat.com>
 
@@ -420,7 +420,6 @@
 
        typeset svc_name=$(getSvcName $DB $svcID) > /dev/null
        typeset export_directory=$(getSvcExportDir $DB $dirtoken) > /dev/null
-       typeset nfs_lock_workaround=$(getSvcMgrNFSLock $DB)
 
         case "$command" in
           start) 
@@ -441,14 +440,7 @@
                    typeset export_args="$export_opt $export_options
$export_client:$export_directory" 
                    ;;
           stop)     
-                   # Use exportfs -u * always to make sure it gets
-                   # sent to the kernel if the workaround is set
-                   if [ "$nfs_lock_workaround" = "yes" ] || \
-                      [ "$nfs_lock_workaround" = "1" ]; then
-                     typeset export_args="-u *:$export_directory" 
-                   else
-                     typeset export_args="-u $export_client:$export_directory" 
-                   fi
+                   typeset export_args="-u $export_client:$export_directory" 
                    ;;
          *)        
                    logAndPrint $LOG_ERR "export_client: Invalid command $command"


Comment 11 Lon Hohberger 2007-05-21 20:10:22 UTC
Tested failover with child-subdirectories (208995 / w/ respinned package) w/
nfs_lock_workaround=1 set.

* service restarted and relocated correctly even with locks on the file system
* rhel4 clients worked fine
* rhel5 client had a problem, but this is not a clumanager issue.


Comment 13 Red Hat Bugzilla 2007-06-14 12:53:47 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0165.html



Note You need to log in before you can comment on or make changes to this bug.